package hideandseek.custommaps;

import java.util.Iterator;
import org.bukkit.inventory.meta.ItemMeta;
import java.lang.reflect.InvocationTargetException;
import hideandseek.xseries.XMaterial;
import org.bukkit.Bukkit;
import org.bukkit.World;
import org.bukkit.map.MapRenderer;
import org.bukkit.map.MapView;
import org.bukkit.inventory.meta.MapMeta;
import java.lang.reflect.Method;
import org.bukkit.inventory.ItemStack;
import java.util.HashMap;

public class CustomMapsManager
{
    private final HashMap<String, ItemStack> maps;
    private Method setMapId;
    private Method setMapView;
    
    public CustomMapsManager() {
        this.maps = new HashMap<String, ItemStack>();
        try {
            this.setMapView = MapMeta.class.getDeclaredMethod("setMapView", MapView.class);
        }
        catch (final SecurityException | NoSuchMethodException var4) {
            try {
                this.setMapId = MapMeta.class.getDeclaredMethod("setMapId", Integer.TYPE);
            }
            catch (final SecurityException | NoSuchMethodException ex) {}
        }
    }
    
    public void clear() {
        this.maps.clear();
    }
    
    public void registerMap(final String var1, final MapRenderer var2) {
        final MapView var3 = Bukkit.createMap((World)Bukkit.getWorlds().get(0));
        for (final MapRenderer var5 : var3.getRenderers()) {
            var3.removeRenderer(var5);
        }
        var3.addRenderer(var2);
        final ItemStack var6 = XMaterial.FILLED_MAP.parseItem();
        if (this.setMapView == null && this.setMapId == null) {
            var6.setDurability((short)this.getViewId(var3));
        }
        else {
            final MapMeta var7 = (MapMeta)var6.getItemMeta();
            if (this.setMapView != null) {
                try {
                    this.setMapView.invoke(var7, var3);
                }
                catch (final IllegalArgumentException | InvocationTargetException | IllegalAccessException var8) {
                    var8.printStackTrace();
                }
            }
            else {
                try {
                    this.setMapId.invoke(var7, this.getViewId(var3));
                }
                catch (final IllegalArgumentException | InvocationTargetException | IllegalAccessException var9) {
                    var9.printStackTrace();
                }
            }
            var6.setItemMeta((ItemMeta)var7);
        }
        this.maps.put(var1, var6);
    }
    
    private int getViewId(final MapView var1) {
        try {
            final String var2 = MapView.class.getMethod("getId", (Class<?>[])new Class[0]).invoke(var1, new Object[0]).toString();
            return Integer.valueOf(var2);
        }
        catch (final IllegalArgumentException | InvocationTargetException | NoSuchMethodException | SecurityException | IllegalAccessException var3) {
            var3.printStackTrace();
            return -1;
        }
    }
    
    public boolean isRegistered(final String var1) {
        return this.maps.containsKey(var1);
    }
    
    public ItemStack getItemStack(final String var1) {
        return this.maps.get(var1);
    }
}
